
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_QUALIFIER_SYMBOL_H
#define PGL_QUALIFIER_SYMBOL_H

#include "PglExprSym.h"

class QualifSym: public ExpressionSym {
	public:
		enum Kind { qfNone, qfLmt, qfNow, qfNmt };

	public:
		QualifSym(Kind aKind = qfNone);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		Kind kind() const { return theKind; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		Kind theKind;
};

#endif
