
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_SIZE_SYMBOL_H
#define PGL_SIZE_SYMBOL_H

#include "BigSize.h"
#include "PglExprSym.h"

class TimeSym;
class BwidthSym;
class RateSym;
class NumSym;

// size

class SizeSym: public ExpressionSym {
	public:
		SizeSym(const BigSize &aVal);

		BigSize val() const { return theVal; }
		void val(BigSize v) { theVal = v; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		ExpressionSym *operSS(const String &op, SizeSym *ss, const SynSym &exp) const;
		ExpressionSym *operST(const String &op, TimeSym *ts, const SynSym &s) const;
		ExpressionSym *operSR(const String &op, RateSym *rs, const SynSym &s) const;
		ExpressionSym *operSB(const String &op, BwidthSym *bs, const SynSym &s) const;
		ExpressionSym *operSN(const String &op, NumSym *ns, const SynSym &exp) const;

	protected:
		BigSize theVal;
};

#endif
