
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_PHASE_SYMBOL_H
#define PGL_PHASE_SYMBOL_H

#include "xstd/String.h"
#include "xstd/Array.h"
#include "pgl/PglRecSym.h"

class GoalSym;
class StatsSampleSym;

// base class for robot and server symbols
class PhaseSym: public RecSym {
	public:
		PhaseSym();
		PhaseSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		void name(const String &aName);

		String name() const;
		GoalSym *goal() const;
		bool recurFactorBeg(double &rf) const;
		bool recurFactorEnd(double &rf) const;
		bool loadFactorBeg(double &f) const;
		bool loadFactorEnd(double &f) const;
		bool statsSamples(Array<const StatsSampleSym*> &samples) const;
		bool logStats(bool &ls) const;
		bool waitWssFreeze(bool &wwf) const;
};

#endif
