
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_UNIQUE_ID_SYMBOL_H
#define PGL_UNIQUE_ID_SYMBOL_H

#include "base/UniqId.h"
#include "PglExprSym.h"

// uniq identifier; used for things like world id, etc.

class UniqIdSym: public ExpressionSym {
	public:
		UniqIdSym(const UniqId &aVal);

		const UniqId &val() const { return theVal; }
		void val(const UniqId &aVal) { theVal = aVal; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		UniqId theVal;
};

#endif
