
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_VARIOUS_POP_DISTRIBUTION_CLASSES_H
#define PGL_VARIOUS_POP_DISTRIBUTION_CLASSES_H

#include "PopDistr.h"

// uniform
class UnifPopDistr: public PopDistr {
	public:
		virtual int choose(RndGen &rng, int lastName);
		virtual ostream &print(ostream &os) const;
};

// zipf power law emulation
class ZipfPopDistr: public PopDistr {
	public:
		ZipfPopDistr(double aSkew = 1);

		virtual int choose(RndGen &rng, int lastName);
		virtual ostream &print(ostream &os) const;

	protected:
		double theSkew;
};

#endif
