
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_STAT_INTERVAL_H
#define PG_STAT_INTERVAL_H

#include "AlarmClock.h"
//#include "polyBcastChannels.h"
#include "runtime/BcastRcver.h"

class Connection;
class Xaction;
class IcpCltXact;
class StatIntvlRec;

// collects and aggregates simple stats in StatIntvlRec
// base class for StatCycle and StatPhase
class StatIntvl: public AlarmUser, public BcastRcver {
	public:
		static void ActiveCat(int cat);
		static int TheReportCat; // which log category to report

	public:
		StatIntvl();

		virtual void noteConnEvent(BcastChannel *ch, const Connection *c);
		virtual void noteXactEvent(BcastChannel *ch, const Xaction *x);
		virtual void noteIcpXactEvent(BcastChannel *, const IcpXaction *x);

		Time startTime() const { return theIntvlStart; }

	protected:
		// these should check that cat is not lgcAll
		virtual StatIntvlRec &getRec(int cat) = 0;
		virtual const StatIntvlRec &getRec(int cat) const = 0;

		void setDuration(Time start);
		void storeAll(OLog &ol, int tag) const;
		
		void report(ostream &os) const;

	protected:
		static Array<bool> IsActiveCat;

		Time theIntvlStart;
};

#endif
