
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "xstd/gadgets.h"
#include "runtime/httpHdrs.h"
#include "server/SrvHistory.h"
#include "server/CltGroupRep.h"


CltGroupRep::CltGroupRep(const UniqId &anId, int aGroupIdx):
	theId(anId), theGroupIdx(aGroupIdx),
	theReqPos(-1), theRepPos(-1), 
	theNidPack(-1), theNidStart(-1), theNidCount(0) {
}


void CltGroupRep::syncGroupInfo(const ReqHdr &req, SrvHistory &hist) {
	if (req.theSendPos > theReqPos)
		theReqPos = req.theSendPos;

	// ignore old info
	if (req.theNidPack <= theNidPack)
		return;

	theNidPack = req.theNidPack;
	theNidStart = hist.newOids(req.theNidCount, theNidCount);
}
