
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xstd.h"

#include <math.h>
#include <iostream.h>
#include <stdlib.h>

#include "Assert.h"
#include "NetDouble.h"


NetDouble::NetDouble(double x) {
	mnt = (int) floor(0x7fffffff * frexp(x, &exp));
}

NetDouble::operator double() const {
	// avoid floating point exceptions on overflows when we read
	// invalid data
	return abs(exp) <= 1024 ? ldexp(mnt/(double)0x7fffffff, exp) : -1;
}
